/* 
@goto BadRexx
*/

/* Remote command handler for AverMedia TVPhone98 card 
based on part of TvShow project by doctor64 */

/*
This script was created for remote control of:
mp3 player Z! by dink, 
TVShow by doctor64, 
WarpVision by Vlad Stelmahovsky, 
Simple CD Player for OS/2 v.1.07 (c) Dmitry Kubov 1996-1998
turn off PC with APM/2 by Roman Stangle
CoolFM 2.0 by Eugene Gorbunoff
*/

/* 'echo d:\Music >mp3path'*/

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs
'@cls'

TempDir=value('temp',,'OS2ENVIRONMENT')"\"
say "Temp dir: "TempDir

ExpList='controlPipe TempDir'

/* 祭  㬮砭 */
Mode="" /*  祬 ࠡ⠥ */
button=-1   /*  ஢  */

ControlPipe=0

/* ।塞   */
videopipe="WV"
audiopipe="zmp3"
TVPipe="tvshow"
FMpipe="COOLFMCONTROL"
CDpipe="CDP00"

/* ५  ⨬ - tvshowrcd.exe */
'@go -ka tvshowrcd.exe >nul'
call syssleep(1)
'@detach tvshowrcd.exe'
call syssleep(2)
pipe2="\pipe\tvshowremote"

/* 稭  PIPE   */
call stream pipe2,'C','CLOSE'
parse value stream stream(pipe2,'C','OPEN') with Pipestate ':' 
if rc=231 then call SysWaitNamedPipe(pipe2,-1)

do forever
	Old_Mode=Mode
	OLD_Button=Button
	parse value linein(pipe2) with token1 token2

	/* ..  諥 ᨣ  ⨨  ᪠ */
	/* ⮣  ࠡ뢠 ⮫쪮  ᨣ  ⨨ */
	if length(token2)=5 then
		Key=substr(token2,1,1)
	else
		Key=substr(token2,2,1)

   if (token1="RCCODE:") & (key="D" | key="5") then	do
		say ' ' token2
		say '  ' MODE
		button=""
		Select
			/*  */
			when (token2="C57000") then MODE="SYSTEM" /*  Teletext */
			when (token2="257000") then MODE="VIDEO"
			when (token2="157000") then MODE="AUDIO"
			when (token2="457000") then MODE="CD"
			when (token2="857000") then do
				select
					when (mode<>"TV") & (mode<>"FM") then MODE="TV"
					when (mode="TV") then MODE="FM"
					when (mode="FM") then MODE="TV"
				otherwise	
				end
			end
		    /* ᫨ ࠭ ०, ⮣ 稬-몫稬 ⨭ */
			when (MODE<>"") & (token2="57000") then Button="POWER" 
			when (MODE<>"") then
			 	Select		
					/* 窨 */
					when (token2="A57000") then Button="1"
					when (token2="657000") then Button="2"
					when (token2="E57000") then Button="3"
					when (token2="957000") then Button="4"
					when (token2="557000") then Button="5"
					when (token2="D57000") then Button="6"
					when (token2="B57000") then Button="7"
					when (token2="757000") then Button="8"
					when (token2="F57000") then Button="9"
					when (token2="8D7000") then Button="0"
					when (token2="C5F000") then Button="C+" /* channel + */
					when (token2="45F000") then Button="C-" /* channel - */
					when (token2="5D7000") then Button="PAUSE"
					when (token2="DD7000") then Button="STOP"
					when (token2="1D7000") then Button="PLAY"
					when (token2="FD7000") then Button="VOL+"
					when (token2="7D7000") then Button="VOL-"
					when (token2="2D7000") then Button="MUTE"
					when (token2="357000") then Button="FS"
					when (token2="AD7000") then Button="AUTOSCAN"
					when (token2="9D7000") then Button="RECORD"
				otherwise
					Button=""
				end

		otherwise
			Button=""
		end

		/* Close old pipe */
		interpret "TempX= "old_mode"pipe"
		OldPipe='\pipe\'TempX
		call stream OldPipe,'C','CLOSE'

		/* Open new pipe */
		interpret "TempX= "mode"pipe"
		ControlPipe='\pipe\'TempX

		rc=SysWaitNamedPipe(ControlPipe,2000) 
		if rc=231 then say "Pipe "ControlPipe" busy"
		say "SysWaitPipe "ControlPipe" = "rc
	
		say " * Control "
		say "MODE" MODE
		say "Button "Button
		say "OLD_MODE" OLD_MODE
		say "OLD_Button" OLD_Button
		say " pipe "ControlPipe

		if (MODE<>"") then call Control MODE, Button
    end
end
call stream pipe2,'C','CLOSE'
exit

/*  ० ࠡ  । ࠢ  楤ࠬ ࠢ */
Control: Procedure expose (ExpList)
arg Mode, Button
say mode button
	Select
		when MODE="TV" then call TVControl with MODE, Button
		when MODE="FM" then call FMControl with MODE, Button
		when MODE="VIDEO" then call VideoControl with MODE, Button
		when MODE="AUDIO" then call AudioControl with MODE, Button
		when MODE="CD" then call CDControl with MODE, Button
		when MODE="SYSTEM" then call SystemControl with MODE, Button
		otherwise
	end
return /* Control */

/*  믮饣 EXE । ᮢ*/
SearchEXE: procedure
arg EXEName

	EXEName=TRANSLATE(EXEName)

	say "Search EXE: "EXEName

    newq = RXQUEUE( 'Create' )  /*    Say ' ।:' newq */
    od = RXQUEUE( 'Set', newq ) /*    Say ' ⨢ ।:' od */
    do while (queued()>0)   /* Clear queue */
       pull .
    end

	'@go |find "'EXEName'" |rxqueue' newq
	if queued()>0 then 
		res=1
	else
		res=0

	od = RXQUEUE( 'Delete', newq )  /*   Say ' ।:' od */

	say EXEName" found = "res

return res /* SearchEXE*/

/* ࠢ Z! */
AudioControl: Procedure expose (ExpList)
arg MODE, Button
say "Z! Control"

ControlList.1 = 'z -p'TempDir'list.pl'
ControlList.2 = 'go -ka z.exe >nul'

AudioSoft_on  = SearchEXE("z.exe")

	if (Button="POWER") then do
		Select
			when (AudioSoft_on=0) then do /* ⨬  */
				MusicDir=getMp3Path() /* ᭨, 㤠  ᯨ᮪ 䠩 */
				say "Music dir: " MusicDIr
				'@dir "'MusicDir'*.mp3" /s /f >'TempDir'list.pl'
				'@ start /b /c 'ControlList.1 
			end
			when (AudioSoft_on=1) then do /* 몫稬 Z */
				call lineout ControlPipe, "*quit" 
				'@del c:\temp\list.pl>nul'
			end
			otherwise
		end
	end

	/* ᫨ ⨭ 饭, ⮣ 㤥  ࠢ */
	if (AudioSoft_on=1) then do
		say "Command selection section Z!"
		act=''
		Select
			when (Button="C+") | (Button="8") | (Button="6") then act="*next" 
			when (Button="C-") | (Button="2") | (Button="4") then act="*previous"
			when Button="PAUSE" then act="*pause" 
			when Button="STOP" then act="*pause" 
			when Button="PLAY" then act="*play" 
			when Button="VOL+" then act="*vol+"
			when Button="VOL-" then act="*vol-"
			when Button="MUTE" then act="*mute"
			when (Button="3") then do /* 10 songs forward */
				act=""
				do 10
					'echo *next >'ControlPipe
					Temp=syssleep(0.5)
				end
			end
			when (Button="1") then do /* 10 songs backward */
				act=""
				do 10
					'echo *previous >'ControlPipe
					Temp=syssleep(0.5)
				end
			end
		otherwise
		end
		if act<>"" then	do
			say "Z! echo "act" to pipe "ControlPipe
			'echo 'act' >'ControlPipe
		end
	end	
return

/* ࠢ OS/2 */
SystemControl: Procedure expose (ExpList)
arg MODE, Button
say "OS/2 Control"

ControlList.1 = 'Apm.exe /Poweroff-'
ControlList.2 = 'go -ka Apm.exe >nul'

OS2Soft_on   = SearchEXE("apm.exe")

if (Button="POWER") then
	select 
		when (OS2Soft_on=0) then do /* ⨬  */
			'start /c /f 'ControlList.1 /* 몫稬 設*/
		end
		when (OS2Soft_on=1) then do 
			'start /c /b 'ControlList.2 /* ⬥ 몫祭 */
		end
	otherwise
	end
return

/* ࠢ ⥫஬ */
TVControl: Procedure expose (ExpList)
arg MODE, Button
say "TV-Control"

ControlList.1 = 'c:\os2apps\tv\tv.cmd >nul'
ControlList.2 = 'go -ka tvshow.exe >nul'

TVSoft_on     = SearchEXE("tvshow.exe")
 
if (Button="POWER") then
	Select
		when (TVSoft_on=0) then do 
			say "TV on"
			'start /f /c 'ControlList.1
		end
		when (TVSoft_on=1) then do 
			say "TV off"
			'start /c /b 'ControlList.2
		end
		otherwise
	end

	/* ᫨ ⨭ 饭, ⮣ 㤥  ࠢ */
	if (TVSoft_on=1) then do
		act=''
		Select
			when (Button="C+") then act="NEXTCHANNEL" 
			when (Button="C-") then act="PREVCHANNEL" 
			when (Button="PAUSE") | (Button="STOP") then call TVControl "TV","POWER" 
			when (Button="1") | (Button="2") | (Button="3") then act="CHANNEL "Button
			when (Button="4") | (Button="5") | (Button="6") then act="CHANNEL "Button
			when (Button="7") | (Button="8") | (Button="9") then act="CHANNEL "Button
			when Button="MUTE" then act="MUTE"
		otherwise
		end
		if act<>"" then	'echo 'act' >'ControlPipe
	end	

return

/* ࠢ WarpVision */
VideoControl: Procedure expose (ExpList)
arg MODE, Button
say "WV Control"

ControlList.1 = 'video2.cmd'
ControlList.2 = 'go -ka video2.exe >nul'

VideoSoft_on  = SearchEXE("video2.exe")

	if (Button="POWER") then do
		say "Video power"
		Select
			when (VideoSoft_on=0) then do /* ⨬  */
				'@ start /f /c 'ControlList.1
			end
			when (VideoSoft_on=1) then do /* 몫稬 */
				/*'echo shutdown >'ControlPipe*/
				'@ start /b /c /min 'ControlList.2
				'@del c:\temp\list.pl'
			end
			otherwise
		end
	end
	say "VideoSoft_on" VideoSoft_on
	/* ᫨ ⨭ 饭, ⮣ 㤥  ࠢ */
	if 	(VideoSoft_on=1) then do
		act=''
		Select
			when (Button="C+") | (Button="8") then act="*next" 
			when (Button="C-") | (Button="2") then act="*previous"
			when Button="PAUSE" then act="flip pause" 
			when Button="STOP" then act="pause" 
			when Button="PLAY" then act="play"
			when Button="MUTE" then act="flip mute"
			when Button="FS" then act="flip fs"
			when (Button="1") then act="seek back 300"
			when (Button="2") then act="seek fwd 600"
			when (Button="3") then act="seek fwd 300"
			when (Button="4") then act="seek back 60"
			when (Button="6") then act="seek fwd 60"
			when (Button="7") then act="seek back 10"
			when (Button="8") then act="seek back 600"
			when (Button="9") then act="seek fwd 10"
		otherwise
		end
		say act
		if act<>"" then	'echo 'act' >'ControlPipe
	end	
return

/* ࠢ FM-tuner */
FMControl: Procedure expose (ExpList)
arg MODE, Button
say "FM Control"

ControlList.1 = 'radio.cmd' /* radio.cmd' */
ControlList.2 = 'go -ka coolfm.exe >nul' /*  BTRADIO_WARPED.EXE */
FMSoft_on     = SearchEXE("coolfm.exe")

if (Button="POWER") then
	select 
		when (FMSoft_on=0) then do /* ⨬  */
			'start /f /c 'ControlList.1 /* Start programm */
		end
		when (FMSoft_on=1) then do 
			'start /c /b 'ControlList.2 /* Kill programm */
		end
	otherwise
	end

	/* ᫨ ⨭ 饭, ⮣ 㤥  ࠢ */
	if (FMSoft_on=1) then do
		act=''
		Select
			when (Button="C+") | (Button="8") | (Button="6") then act="$Next" 
			when (Button="C-") | (Button="2") | (Button="4") then act="$Prev"
			when Button="MUTE" then act="$switchmute"
			when Button="RECORD" then act="$switchrecord"
		otherwise
		end
		if act<>"" then	do /*'echo 'act' >'ControlPipe*/
		    opret = stream(pname,"C","open write")
		    if opret == "READY:" then do
		        call lineout ControlPipe,act
				call stream ControlPipe,'C','CLOSE'
			    end
			else do
				echo "Cannot open CoolFM pipe "opret
			end
		end
return


/* ࠢ CD */
CDControl: Procedure expose (ExpList)
arg MODE, Button
say "CD Control"

ControlList.1 = 'cdp.exe'
ControlList.2 = 'go -ka cdp.exe >nul'
CDSoft_on     = SearchEXE("cdp.exe")

	if (Button="POWER") then do
		Select
			when (CDSoft_on=0) then do /* ⨬  */
				'@ start /b /c 'ControlList.1 
			end
			when (CDSoft_on=1) then do /* 몫稬 CDP */
/*				call lineout ControlPipe, "quit" */
				'@ start /b /c /min 'ControlList.2  
			end
			otherwise
		end
	end

	/* ᫨ ⨭ 饭, ⮣ 㤥  ࠢ */
	if (CDSoft_on=1) then do
		act=''
		Select
			when (Button="C+") | (Button="8") | (Button="6") then act="next" 
			when (Button="C-") | (Button="2") | (Button="4") then act="previous"
			when Button="PAUSE" then act="pause"
			when Button="STOP" then act="stop" 
			when Button="PLAY" then act="play" 
			when Button="MUTE" then act="pause"
			when (Button="3") then do /* 10 songs forward */
				act=""
				do 10
					'echo next >'ControlPipe
					Temp=syssleep(0.4)
				end
			end
			when (Button="1") then do /* 10 songs backward */
				act=""
				do 10
					'echo previous >'ControlPipe
					Temp=syssleep(0.4)
				end
			end
		otherwise
		end
		if act<>"" then	'echo 'act' >'ControlPipe
	end	
return

/*  䠩 mp3path  ⠥   ப  ⥬  mp3*/
GetMp3Path: Procedure
describename = stream('mp3path','C','query exists')
say "GetMP3path IN"
RetValue=''
if describename \= '' then
do
  destream = stream(describename,'C','open')
  if destream = "READY:" then
  do
    call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
    call SysLoadFuncs
    do while lines(describename)
      text = linein(describename)
      if text \= '' then
      do
        if left(text,1) \= ' ' then
        do
          if left(text,1) \= '-' then
          do
            parse var text 
              if text \= '' then
              do
				say text
				text=strip(text)
				if right(text,1)\="\" then text=text"\" /*substr(text,1,length(text)-1)*/
				RetValue=text
              end
          end
        end
      end
    end
    call stream describename,'C','close'
  end
end
else
  say 'File mp3path not found in current directory.'
say "result " RetValue
return RetValue

:BadRexx
@echo Error: REXX not present.

